<?php

namespace Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustWithRegInfo Array
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCustWithRegInfo
 * @subpackage Arrays
 * @date 2019-10-21
 */
class ArrayOfCustWithRegInfo extends AbstractStructArrayBase
{
    /**
     * The CustWithRegInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Struct\CustWithRegInfo[]
     */
    public $CustWithRegInfo;
    /**
     * Constructor method for ArrayOfCustWithRegInfo
     * @uses ArrayOfCustWithRegInfo::setCustWithRegInfo()
     * @param \Struct\CustWithRegInfo[] $custWithRegInfo
     */
    public function __construct(array $custWithRegInfo = array())
    {
        $this
            ->setCustWithRegInfo($custWithRegInfo);
    }
    /**
     * Get CustWithRegInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Struct\CustWithRegInfo[]|null
     */
    public function getCustWithRegInfo()
    {
        return isset($this->CustWithRegInfo) ? $this->CustWithRegInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustWithRegInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustWithRegInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustWithRegInfoForArrayConstraintsFromSetCustWithRegInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustWithRegInfoCustWithRegInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustWithRegInfoCustWithRegInfoItem instanceof \Struct\CustWithRegInfo) {
                $invalidValues[] = is_object($arrayOfCustWithRegInfoCustWithRegInfoItem) ? get_class($arrayOfCustWithRegInfoCustWithRegInfoItem) : sprintf('%s(%s)', gettype($arrayOfCustWithRegInfoCustWithRegInfoItem), var_export($arrayOfCustWithRegInfoCustWithRegInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustWithRegInfo property can only contain items of type \Struct\CustWithRegInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustWithRegInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Struct\CustWithRegInfo[] $custWithRegInfo
     * @return \Array\ArrayOfCustWithRegInfo
     */
    public function setCustWithRegInfo(array $custWithRegInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($custWithRegInfoArrayErrorMessage = self::validateCustWithRegInfoForArrayConstraintsFromSetCustWithRegInfo($custWithRegInfo))) {
            throw new \InvalidArgumentException($custWithRegInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($custWithRegInfo) || (is_array($custWithRegInfo) && empty($custWithRegInfo))) {
            unset($this->CustWithRegInfo);
        } else {
            $this->CustWithRegInfo = $custWithRegInfo;
        }
        return $this;
    }
    /**
     * Add item to CustWithRegInfo value
     * @throws \InvalidArgumentException
     * @param \Struct\CustWithRegInfo $item
     * @return \Array\ArrayOfCustWithRegInfo
     */
    public function addToCustWithRegInfo(\Struct\CustWithRegInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Struct\CustWithRegInfo) {
            throw new \InvalidArgumentException(sprintf('The CustWithRegInfo property can only contain items of type \Struct\CustWithRegInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustWithRegInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Struct\CustWithRegInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Struct\CustWithRegInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Struct\CustWithRegInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Struct\CustWithRegInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Struct\CustWithRegInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustWithRegInfo
     */
    public function getAttributeName()
    {
        return 'CustWithRegInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Array\ArrayOfCustWithRegInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
