<?php

namespace Array;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeliveryChannelType Array
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeliveryChannelType
 * @subpackage Arrays
 * @date 2019-10-21
 */
class ArrayOfDeliveryChannelType extends AbstractStructArrayBase
{
    /**
     * The DeliveryChannelType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Struct\DeliveryChannelType[]
     */
    public $DeliveryChannelType;
    /**
     * Constructor method for ArrayOfDeliveryChannelType
     * @uses ArrayOfDeliveryChannelType::setDeliveryChannelType()
     * @param \Struct\DeliveryChannelType[] $deliveryChannelType
     */
    public function __construct(array $deliveryChannelType = array())
    {
        $this
            ->setDeliveryChannelType($deliveryChannelType);
    }
    /**
     * Get DeliveryChannelType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Struct\DeliveryChannelType[]|null
     */
    public function getDeliveryChannelType()
    {
        return isset($this->DeliveryChannelType) ? $this->DeliveryChannelType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeliveryChannelType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeliveryChannelType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeliveryChannelTypeForArrayConstraintsFromSetDeliveryChannelType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeliveryChannelTypeDeliveryChannelTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeliveryChannelTypeDeliveryChannelTypeItem instanceof \Struct\DeliveryChannelType) {
                $invalidValues[] = is_object($arrayOfDeliveryChannelTypeDeliveryChannelTypeItem) ? get_class($arrayOfDeliveryChannelTypeDeliveryChannelTypeItem) : sprintf('%s(%s)', gettype($arrayOfDeliveryChannelTypeDeliveryChannelTypeItem), var_export($arrayOfDeliveryChannelTypeDeliveryChannelTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeliveryChannelType property can only contain items of type \Struct\DeliveryChannelType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeliveryChannelType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Struct\DeliveryChannelType[] $deliveryChannelType
     * @return \Array\ArrayOfDeliveryChannelType
     */
    public function setDeliveryChannelType(array $deliveryChannelType = array())
    {
        // validation for constraint: array
        if ('' !== ($deliveryChannelTypeArrayErrorMessage = self::validateDeliveryChannelTypeForArrayConstraintsFromSetDeliveryChannelType($deliveryChannelType))) {
            throw new \InvalidArgumentException($deliveryChannelTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($deliveryChannelType) || (is_array($deliveryChannelType) && empty($deliveryChannelType))) {
            unset($this->DeliveryChannelType);
        } else {
            $this->DeliveryChannelType = $deliveryChannelType;
        }
        return $this;
    }
    /**
     * Add item to DeliveryChannelType value
     * @throws \InvalidArgumentException
     * @param \Struct\DeliveryChannelType $item
     * @return \Array\ArrayOfDeliveryChannelType
     */
    public function addToDeliveryChannelType(\Struct\DeliveryChannelType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Struct\DeliveryChannelType) {
            throw new \InvalidArgumentException(sprintf('The DeliveryChannelType property can only contain items of type \Struct\DeliveryChannelType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeliveryChannelType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Struct\DeliveryChannelType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Struct\DeliveryChannelType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Struct\DeliveryChannelType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Struct\DeliveryChannelType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Struct\DeliveryChannelType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeliveryChannelType
     */
    public function getAttributeName()
    {
        return 'DeliveryChannelType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Array\ArrayOfDeliveryChannelType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
