<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'QueryAvailableItems' => '\\Struct\\QueryAvailableItems',
            'QueryAvailableItemsResponse' => '\\Struct\\QueryAvailableItemsResponse',
            'QueryPoints' => '\\Struct\\QueryPoints',
            'QueryPointsResponse' => '\\Struct\\QueryPointsResponse',
            'GetMyWalletsWithPoints' => '\\Struct\\GetMyWalletsWithPoints',
            'GetMyWalletsWithPointsResponse' => '\\Struct\\GetMyWalletsWithPointsResponse',
            'GetMyWalletsWithStockPoints' => '\\Struct\\GetMyWalletsWithStockPoints',
            'GetMyWalletsWithStockPointsResponse' => '\\Struct\\GetMyWalletsWithStockPointsResponse',
            'IsCustomerRegistered' => '\\Struct\\IsCustomerRegistered',
            'IsCustomerRegisteredResponse' => '\\Struct\\IsCustomerRegisteredResponse',
            'RedemptionHistory' => '\\Struct\\RedemptionHistory',
            'RedemptionHistoryResponse' => '\\Struct\\RedemptionHistoryResponse',
            'QueryStockPoints' => '\\Struct\\QueryStockPoints',
            'QueryStockPointsResponse' => '\\Struct\\QueryStockPointsResponse',
            'GivePoints' => '\\Struct\\GivePoints',
            'GivePointsResponse' => '\\Struct\\GivePointsResponse',
            'TakePoints' => '\\Struct\\TakePoints',
            'TakePointsResponse' => '\\Struct\\TakePointsResponse',
            'GetCommandPrice' => '\\Struct\\GetCommandPrice',
            'GetCommandPriceResponse' => '\\Struct\\GetCommandPriceResponse',
            'BuyPoints' => '\\Struct\\BuyPoints',
            'BuyPointsResponse' => '\\Struct\\BuyPointsResponse',
            'RedeemItems' => '\\Struct\\RedeemItems',
            'RedeemItemsResponse' => '\\Struct\\RedeemItemsResponse',
            'RedeemItemsBeta' => '\\Struct\\RedeemItemsBeta',
            'RedeemItemsBetaResponse' => '\\Struct\\RedeemItemsBetaResponse',
            'CancelRedeem' => '\\Struct\\CancelRedeem',
            'CancelRedeemResponse' => '\\Struct\\CancelRedeemResponse',
            'DeliverItems' => '\\Struct\\DeliverItems',
            'DeliverItemsResponse' => '\\Struct\\DeliverItemsResponse',
            'GetCommandRestrictions' => '\\Struct\\GetCommandRestrictions',
            'GetCommandRestrictionsResponse' => '\\Struct\\GetCommandRestrictionsResponse',
            'GetLineMembersWalletsCount' => '\\Struct\\GetLineMembersWalletsCount',
            'GetLineMembersWalletsCountResponse' => '\\Struct\\GetLineMembersWalletsCountResponse',
            'GetLineMembersPoints' => '\\Struct\\GetLineMembersPoints',
            'GetLineMembersPointsResponse' => '\\Struct\\GetLineMembersPointsResponse',
            'GetAvailableWalletsForCommand' => '\\Struct\\GetAvailableWalletsForCommand',
            'GetAvailableWalletsForCommandResponse' => '\\Struct\\GetAvailableWalletsForCommandResponse',
            'GetTransferDetails' => '\\Struct\\GetTransferDetails',
            'GetTransferDetailsResponse' => '\\Struct\\GetTransferDetailsResponse',
            'UnRegister' => '\\Struct\\UnRegister',
            'UnRegisterResponse' => '\\Struct\\UnRegisterResponse',
            'Register' => '\\Struct\\Register',
            'RegisterResponse' => '\\Struct\\RegisterResponse',
            'RedeemableItemDetails' => '\\Struct\\RedeemableItemDetails',
            'RedeemableItemDetailsResponse' => '\\Struct\\RedeemableItemDetailsResponse',
            'EnableCustomer' => '\\Struct\\EnableCustomer',
            'EnableCustomerResponse' => '\\Struct\\EnableCustomerResponse',
            'DisableCustomer' => '\\Struct\\DisableCustomer',
            'DisableCustomerResponse' => '\\Struct\\DisableCustomerResponse',
            'GetOrdersSummary' => '\\Struct\\GetOrdersSummary',
            'GetOrdersSummaryResponse' => '\\Struct\\GetOrdersSummaryResponse',
            'GetCataloguesSummary' => '\\Struct\\GetCataloguesSummary',
            'GetCataloguesSummaryResponse' => '\\Struct\\GetCataloguesSummaryResponse',
            'AddPoints' => '\\Struct\\AddPoints',
            'AddPointsResponse' => '\\Struct\\AddPointsResponse',
            'RemovePoints' => '\\Struct\\RemovePoints',
            'RemovePointsResponse' => '\\Struct\\RemovePointsResponse',
            'GetAccountMembersWithRegistrationInfo' => '\\Struct\\GetAccountMembersWithRegistrationInfo',
            'GetAccountMembersWithRegistrationInfoResponse' => '\\Struct\\GetAccountMembersWithRegistrationInfoResponse',
            'BalanceHistory' => '\\Struct\\BalanceHistory',
            'BalanceHistoryResponse' => '\\Struct\\BalanceHistoryResponse',
            'GetLostPoints' => '\\Struct\\GetLostPoints',
            'GetLostPointsResponse' => '\\Struct\\GetLostPointsResponse',
            'GetNextRedemptionDate' => '\\Struct\\GetNextRedemptionDate',
            'GetNextRedemptionDateResponse' => '\\Struct\\GetNextRedemptionDateResponse',
            'PasswordRequest' => '\\Struct\\PasswordRequest',
            'PasswordRequestResponse' => '\\Struct\\PasswordRequestResponse',
            'SendEmailLink' => '\\Struct\\SendEmailLink',
            'SendEmailLinkResponse' => '\\Struct\\SendEmailLinkResponse',
            'QueryDefaultAvailableItems' => '\\Struct\\QueryDefaultAvailableItems',
            'QueryDefaultAvailableItemsResponse' => '\\Struct\\QueryDefaultAvailableItemsResponse',
            'GetDeliveryChannels' => '\\Struct\\GetDeliveryChannels',
            'GetDeliveryChannelsResponse' => '\\Struct\\GetDeliveryChannelsResponse',
            'GetAvailableQuantity' => '\\Struct\\GetAvailableQuantity',
            'GetAvailableQuantityResponse' => '\\Struct\\GetAvailableQuantityResponse',
            'ChangePassword' => '\\Struct\\ChangePassword',
            'ChangePasswordResponse' => '\\Struct\\ChangePasswordResponse',
            'GetDeliveryChannelTypes' => '\\Struct\\GetDeliveryChannelTypes',
            'GetDeliveryChannelTypesResponse' => '\\Struct\\GetDeliveryChannelTypesResponse',
            'GetAreas' => '\\Struct\\GetAreas',
            'GetAreasResponse' => '\\Struct\\GetAreasResponse',
            'GetArea' => '\\Struct\\GetArea',
            'GetAreaResponse' => '\\Struct\\GetAreaResponse',
            'Customer' => '\\Struct\\Customer',
            'RedeemableItemsResponse' => '\\Struct\\RedeemableItemsResponse',
            'ApiResponse' => '\\Struct\\ApiResponse',
            'WalletsResponse' => '\\Struct\\WalletsResponse',
            'QueryRedemptionHistoryResponse' => '\\Struct\\QueryRedemptionHistoryResponse',
            'CommandPriceResponse' => '\\Struct\\CommandPriceResponse',
            'RedemptionResponse' => '\\Struct\\RedemptionResponse',
            'DeliverItemsRequest' => '\\Struct\\DeliverItemsRequest',
            'CommandRestrictionsResponse' => '\\Struct\\CommandRestrictionsResponse',
            'WalletsTransferDetailsResponse' => '\\Struct\\WalletsTransferDetailsResponse',
            'OrdersSummaryResponse' => '\\Struct\\OrdersSummaryResponse',
            'CataloguesSummaryResponse' => '\\Struct\\CataloguesSummaryResponse',
            'NextRedemptionDateResponse' => '\\Struct\\NextRedemptionDateResponse',
            'DeliveryChannelsResponse' => '\\Struct\\DeliveryChannelsResponse',
            'DeliveryChannelTypesResponse' => '\\Struct\\DeliveryChannelTypesResponse',
            'AreasResponse' => '\\Struct\\AreasResponse',
            'Error' => '\\Struct\\Error',
            'ArrayOfRedeemableItem' => '\\Array\\ArrayOfRedeemableItem',
            'RedeemableItem' => '\\Struct\\RedeemableItem',
            'RedeemableItemCatalogue' => '\\Struct\\RedeemableItemCatalogue',
            'ArrayOfRedeemableItemCategory' => '\\Array\\ArrayOfRedeemableItemCategory',
            'RedeemableItemCategory' => '\\Struct\\RedeemableItemCategory',
            'ArrayOfRedeemableItemPrice' => '\\Array\\ArrayOfRedeemableItemPrice',
            'RedeemableItemPrice' => '\\Struct\\RedeemableItemPrice',
            'WalletType' => '\\Struct\\WalletType',
            'ArrayOfWallet' => '\\Array\\ArrayOfWallet',
            'Wallet' => '\\Struct\\Wallet',
            'ArrayOfStock' => '\\Array\\ArrayOfStock',
            'Stock' => '\\Struct\\Stock',
            'ArrayOfRedemptionLog' => '\\Array\\ArrayOfRedemptionLog',
            'RedemptionLog' => '\\Struct\\RedemptionLog',
            'ArrayOfRedemptionItemsLog' => '\\Array\\ArrayOfRedemptionItemsLog',
            'RedemptionItemsLog' => '\\Struct\\RedemptionItemsLog',
            'Command' => '\\Struct\\Command',
            'DeliveryChannel' => '\\Struct\\DeliveryChannel',
            'ArrayOfRedemptionItemPointsLog' => '\\Array\\ArrayOfRedemptionItemPointsLog',
            'RedemptionItemPointsLog' => '\\Struct\\RedemptionItemPointsLog',
            'CommandReason' => '\\Struct\\CommandReason',
            'ArrayOfPurchaseOrderItem' => '\\Array\\ArrayOfPurchaseOrderItem',
            'PurchaseOrderItem' => '\\Struct\\PurchaseOrderItem',
            'ArrayOfPurchaseOrderItemInfo' => '\\Array\\ArrayOfPurchaseOrderItemInfo',
            'PurchaseOrderItemInfo' => '\\Struct\\PurchaseOrderItemInfo',
            'CancelRedeemRequest' => '\\Struct\\CancelRedeemRequest',
            'ArrayOfRedeemItemCancel' => '\\Array\\ArrayOfRedeemItemCancel',
            'RedeemItemCancel' => '\\Struct\\RedeemItemCancel',
            'ArrayOfCommandRestriction' => '\\Array\\ArrayOfCommandRestriction',
            'CommandRestriction' => '\\Struct\\CommandRestriction',
            'ArrayOfWalletTransferDetails' => '\\Array\\ArrayOfWalletTransferDetails',
            'WalletTransferDetails' => '\\Struct\\WalletTransferDetails',
            'ArrayOfBalanceLog' => '\\Array\\ArrayOfBalanceLog',
            'BalanceLog' => '\\Struct\\BalanceLog',
            'ArrayOfDeliveryChannel' => '\\Array\\ArrayOfDeliveryChannel',
            'ArrayOfDeliveryChannelType' => '\\Array\\ArrayOfDeliveryChannelType',
            'DeliveryChannelType' => '\\Struct\\DeliveryChannelType',
            'ArrayOfArea' => '\\Array\\ArrayOfArea',
            'Area' => '\\Struct\\Area',
            'ArrayOfunsignedByte' => '\\Array\\ArrayOfunsignedByte',
            'ArrayOfKeyValueOfCustomerintbMZLxG6p' => '\\Array\\ArrayOfKeyValueOfCustomerintbMZLxG6p',
            'KeyValueOfCustomerintbMZLxG6p' => '\\Struct\\KeyValueOfCustomerintbMZLxG6p',
            'ArrayOfKeyValueOfCustomerArrayOfWalletFJlD39bd' => '\\Array\\ArrayOfKeyValueOfCustomerArrayOfWalletFJlD39bd',
            'KeyValueOfCustomerArrayOfWalletFJlD39bd' => '\\Struct\\KeyValueOfCustomerArrayOfWalletFJlD39bd',
            'ArrayOflong' => '\\Array\\ArrayOflong',
            'ArrayOfKeyValueOfshortAreaNNoFT2Ls' => '\\Array\\ArrayOfKeyValueOfshortAreaNNoFT2Ls',
            'KeyValueOfshortAreaNNoFT2Ls' => '\\Struct\\KeyValueOfshortAreaNNoFT2Ls',
            'LineMembersWalletsResponse' => '\\Struct\\LineMembersWalletsResponse',
            'LineMembersPointsResponse' => '\\Struct\\LineMembersPointsResponse',
            'CustWithRegInfoResponse' => '\\Struct\\CustWithRegInfoResponse',
            'ArrayOfCustWithRegInfo' => '\\Array\\ArrayOfCustWithRegInfo',
            'CustWithRegInfo' => '\\Struct\\CustWithRegInfo',
            'ItemsQuantityResponse' => '\\Struct\\ItemsQuantityResponse',
            'AreaResponse' => '\\Struct\\AreaResponse',
            'ArrayOfItemQuantity' => '\\Array\\ArrayOfItemQuantity',
            'ItemQuantity' => '\\Struct\\ItemQuantity',
        );
    }
}
