<?php

namespace Struct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustWithRegInfoResponse Struct
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CustWithRegInfoResponse
 * @subpackage Structs
 * @date 2019-10-21
 */
class CustWithRegInfoResponse extends ApiResponse
{
    /**
     * The Customers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Array\ArrayOfCustWithRegInfo
     */
    public $Customers;
    /**
     * Constructor method for CustWithRegInfoResponse
     * @uses CustWithRegInfoResponse::setCustomers()
     * @param \Array\ArrayOfCustWithRegInfo $customers
     */
    public function __construct(\Array\ArrayOfCustWithRegInfo $customers = null)
    {
        $this
            ->setCustomers($customers);
    }
    /**
     * Get Customers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Array\ArrayOfCustWithRegInfo|null
     */
    public function getCustomers()
    {
        return isset($this->Customers) ? $this->Customers : null;
    }
    /**
     * Set Customers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Array\ArrayOfCustWithRegInfo $customers
     * @return \Struct\CustWithRegInfoResponse
     */
    public function setCustomers(\Array\ArrayOfCustWithRegInfo $customers = null)
    {
        if (is_null($customers) || (is_array($customers) && empty($customers))) {
            unset($this->Customers);
        } else {
            $this->Customers = $customers;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Struct\CustWithRegInfoResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
