<?php

namespace Struct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for QueryRedemptionHistoryResponse Struct
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:QueryRedemptionHistoryResponse
 * @subpackage Structs
 * @date 2019-10-21
 */
class QueryRedemptionHistoryResponse extends ApiResponse
{
    /**
     * The RedemptionLogs
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Array\ArrayOfRedemptionLog
     */
    public $RedemptionLogs;
    /**
     * Constructor method for QueryRedemptionHistoryResponse
     * @uses QueryRedemptionHistoryResponse::setRedemptionLogs()
     * @param \Array\ArrayOfRedemptionLog $redemptionLogs
     */
    public function __construct(\Array\ArrayOfRedemptionLog $redemptionLogs = null)
    {
        $this
            ->setRedemptionLogs($redemptionLogs);
    }
    /**
     * Get RedemptionLogs value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Array\ArrayOfRedemptionLog|null
     */
    public function getRedemptionLogs()
    {
        return isset($this->RedemptionLogs) ? $this->RedemptionLogs : null;
    }
    /**
     * Set RedemptionLogs value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Array\ArrayOfRedemptionLog $redemptionLogs
     * @return \Struct\QueryRedemptionHistoryResponse
     */
    public function setRedemptionLogs(\Array\ArrayOfRedemptionLog $redemptionLogs = null)
    {
        if (is_null($redemptionLogs) || (is_array($redemptionLogs) && empty($redemptionLogs))) {
            unset($this->RedemptionLogs);
        } else {
            $this->RedemptionLogs = $redemptionLogs;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Struct\QueryRedemptionHistoryResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
