<?php

namespace Struct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WalletTransferDetails Struct
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:WalletTransferDetails
 * @subpackage Structs
 * @date 2019-10-21
 */
class WalletTransferDetails extends AbstractStructBase
{
    /**
     * The Wallet
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Struct\Wallet
     */
    public $Wallet;
    /**
     * The WalletsGive
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Array\ArrayOfWallet
     */
    public $WalletsGive;
    /**
     * The WalletsTake
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Array\ArrayOfWallet
     */
    public $WalletsTake;
    /**
     * Constructor method for WalletTransferDetails
     * @uses WalletTransferDetails::setWallet()
     * @uses WalletTransferDetails::setWalletsGive()
     * @uses WalletTransferDetails::setWalletsTake()
     * @param \Struct\Wallet $wallet
     * @param \Array\ArrayOfWallet $walletsGive
     * @param \Array\ArrayOfWallet $walletsTake
     */
    public function __construct(\Struct\Wallet $wallet = null, \Array\ArrayOfWallet $walletsGive = null, \Array\ArrayOfWallet $walletsTake = null)
    {
        $this
            ->setWallet($wallet)
            ->setWalletsGive($walletsGive)
            ->setWalletsTake($walletsTake);
    }
    /**
     * Get Wallet value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Struct\Wallet|null
     */
    public function getWallet()
    {
        return isset($this->Wallet) ? $this->Wallet : null;
    }
    /**
     * Set Wallet value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Struct\Wallet $wallet
     * @return \Struct\WalletTransferDetails
     */
    public function setWallet(\Struct\Wallet $wallet = null)
    {
        if (is_null($wallet) || (is_array($wallet) && empty($wallet))) {
            unset($this->Wallet);
        } else {
            $this->Wallet = $wallet;
        }
        return $this;
    }
    /**
     * Get WalletsGive value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Array\ArrayOfWallet|null
     */
    public function getWalletsGive()
    {
        return isset($this->WalletsGive) ? $this->WalletsGive : null;
    }
    /**
     * Set WalletsGive value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Array\ArrayOfWallet $walletsGive
     * @return \Struct\WalletTransferDetails
     */
    public function setWalletsGive(\Array\ArrayOfWallet $walletsGive = null)
    {
        if (is_null($walletsGive) || (is_array($walletsGive) && empty($walletsGive))) {
            unset($this->WalletsGive);
        } else {
            $this->WalletsGive = $walletsGive;
        }
        return $this;
    }
    /**
     * Get WalletsTake value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Array\ArrayOfWallet|null
     */
    public function getWalletsTake()
    {
        return isset($this->WalletsTake) ? $this->WalletsTake : null;
    }
    /**
     * Set WalletsTake value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Array\ArrayOfWallet $walletsTake
     * @return \Struct\WalletTransferDetails
     */
    public function setWalletsTake(\Array\ArrayOfWallet $walletsTake = null)
    {
        if (is_null($walletsTake) || (is_array($walletsTake) && empty($walletsTake))) {
            unset($this->WalletsTake);
        } else {
            $this->WalletsTake = $walletsTake;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Struct\WalletTransferDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
