<?php

namespace Struct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WalletsResponse Struct
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:WalletsResponse
 * @subpackage Structs
 * @date 2019-10-21
 */
class WalletsResponse extends ApiResponse
{
    /**
     * The Wallets
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Array\ArrayOfWallet
     */
    public $Wallets;
    /**
     * Constructor method for WalletsResponse
     * @uses WalletsResponse::setWallets()
     * @param \Array\ArrayOfWallet $wallets
     */
    public function __construct(\Array\ArrayOfWallet $wallets = null)
    {
        $this
            ->setWallets($wallets);
    }
    /**
     * Get Wallets value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Array\ArrayOfWallet|null
     */
    public function getWallets()
    {
        return isset($this->Wallets) ? $this->Wallets : null;
    }
    /**
     * Set Wallets value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Array\ArrayOfWallet $wallets
     * @return \Struct\WalletsResponse
     */
    public function setWallets(\Array\ArrayOfWallet $wallets = null)
    {
        if (is_null($wallets) || (is_array($wallets) && empty($wallets))) {
            unset($this->Wallets);
        } else {
            $this->Wallets = $wallets;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Struct\WalletsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
